#include <avr/io.h>        // библиотека ввода вывода
#include <util/delay.h>    // библиотека задержек
#include <avr/interrupt.h> // Прерывания
#include "twi.c"           // заголовочный библиотеки TWI
#include "ssd1306.c"
#include  <avr/pgmspace.h>
//#include "AD9833.h"
//#include "AD9833.c"
//#include "spi.h"
//#include "spi.c"
#include "avr/eeprom.h"
#include <stdint.h>

#include "AD9833.h"     // Include the library

#define FNC_PIN 10       // Can be any digital IO pin
AD9833 gen(FNC_PIN);

uint8_t buff[11];   //для хранения отправляемых на экран данных
volatile uint8_t menu=0;
uint8_t refresh=1;
uint8_t rezim=0;
uint8_t vibor=0;

int32_t faza=0;
uint8_t mnoj=1;
int32_t gz=1;
int32_t kgz=0;
int32_t mgz=0;

uint16_t EEMEM e_faza;  
uint8_t EEMEM e_mnoj;  
int16_t EEMEM e_gz;
int16_t EEMEM e_kgz;
int16_t EEMEM e_mgz;  
uint8_t EEMEM e_rezim;
float xxx;

#define SINUS 0
#define TRIANGLE 1
#define MEANDR 2


//кнопонь
ISR(INT0_vect){
  //запретить инт 0
  EIFR&= ~(1<<INTF1) | (1<<INTF0);
  //cli();
  _delay_ms(300);   
  while (!(PIND & (1<<2))) {
    menu=14;
    asm("nop");
  }
  if (menu==0){ //если не в меню{
    vibor++;
    if (vibor==5) vibor =0;
    //menu=10;  //заходим в меню
    }
  else{ 
    switch (menu) {
      case 10:
      rezim=SINUS;
      gen.ApplySignal(SINE_WAVE,REG0,gz+(kgz*1000)+(mgz*1000000));
      menu=0;
      break;
      case 11:
      rezim=TRIANGLE;
      gen.ApplySignal(TRIANGLE_WAVE,REG0,gz+(kgz*1000)+(mgz*1000000));
      menu=0;
      break;
      case 12:
      rezim=MEANDR;
      gen.ApplySignal(SQUARE_WAVE,REG0,(gz+(kgz*1000)+(mgz*1000000)));
      menu=0;
      break;
      case 13:
      eeprom_write_word(&e_faza,faza);
      eeprom_write_byte(&e_mnoj,mnoj);
      eeprom_write_word(&e_gz,gz);
      eeprom_write_word(&e_kgz,kgz);
      eeprom_write_word(&e_mgz,mgz);
      eeprom_write_byte(&e_rezim,rezim);
      menu=0;
      break;
    } 
  }
//sei();
EIFR|= (1<<INTF1) | (1<<INTF0);   
refresh=1; //добавить рефреш странички
}



// крутилка
ISR(INT1_vect){
  unsigned char napr=0;
  if (PINC&(1<<3)) napr=0; else napr=1;
if (menu==0){
  if (vibor==0){
    if (napr==0) faza++; else faza--;
    if (faza>180)faza=0;
  }
  
  if (vibor==1){
    if (mnoj==1)mnoj=10;
    else if (mnoj==10)mnoj=100;
    else if (mnoj==100)mnoj=1;
  }
  
  if (vibor==2){
    if (napr==0) gz=gz+mnoj; else gz=gz-mnoj;
    if (gz>=1000){
      gz=gz-1000;
      kgz++;
    }
    if ((gz<0)&&(kgz>0)) {gz=1000+gz; kgz--;}
    if ((gz<0)&&(kgz==0)) {gz=0;}
  }
  
  if (vibor==3){
    if (napr==0) kgz=kgz+mnoj; else kgz=kgz-mnoj;
    if ((kgz>=1000)&&(mgz<12)){
      kgz=kgz-1000;
      mgz++;
    }
    if ((mgz==12)&&(kgz>=500))kgz=500;
    if (kgz<0&&(mgz>0)) {kgz=1000+kgz; mgz--;}
    if ((kgz<0)&&(mgz==0)) {kgz=0;}
  }
  
  if (vibor==4){
    if (napr==0) mgz++; else mgz--;
    if ((mgz==12)&&(kgz>500)) {mgz=12; kgz=500;}
    if (mgz>12) mgz=12; 
    if (mgz<0) mgz=0;
  } 
  
  } //если не в меню
else{
  menu++;
  if (menu>=14) menu=10;
}
refresh=1;  
}



void Int_To_Buff(uint16_t c, uint8_t *buff)
{
  if (c<0) c=0;
  sprintf(buff, "%.3d", c);
}



void setup() {
  // put your setup code here, to run once:
  DDRB = 0b000101110; 
 PORTB = 0b000101110; 
 DDRD = 0b001100000; 
 PORTD = 0b000000100;
 DDRC = 0b000000000;
 PORTC = 0b000100000;
 
  I2C_Init(); // инициализация i2с шины
  LCD_init(); // инициализация дисплея.
 // spi_init(SPIMODE2);
  
  faza=eeprom_read_word(&e_faza);
  if (faza>360||faza<0)faza=0;
  mnoj=eeprom_read_byte(&e_mnoj);
  if((mnoj!=1)||(mnoj!=10)||(mnoj!=100))mnoj=1;
  gz=eeprom_read_word(&e_gz);
  if (gz>1000||gz<0)gz=100;
  kgz=eeprom_read_word(&e_kgz);
  if (kgz>1000||kgz<0)kgz=0;
  mgz=eeprom_read_word(&e_mgz);
  if (mgz>12||mgz<0)mgz=0;
  rezim=eeprom_read_byte(&e_rezim);
  if (rezim>2)rezim=0;
 // ad9833_init(rezim, 100);
 // ad9833_set_frequency(0, gz+(kgz*1000)+(mgz*1000000));

  

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA|=(1<<ISC11) | (1<<ISC10) | (1<<ISC01) | (1<<ISC00);// INT Mode: Rising Edge
EIMSK|=(1<<INT1) | (1<<INT0);  // INT: On
EIFR|=(1<<INTF1) | (1<<INTF0);
PCICR|=(0<<PCIE2) | (0<<PCIE1) | (0<<PCIE0);

LCD_Clear(); 
menu=0;
sei();//разрешить прерывания

    gen.Begin();  
                
    if (rezim==SINUS) gen.ApplySignal(SINE_WAVE,REG0,gz+(kgz*1000)+(mgz*1000000));
    if (rezim==TRIANGLE) gen.ApplySignal(TRIANGLE_WAVE,REG0,gz+(kgz*1000)+(mgz*1000000));
    if (rezim==MEANDR) gen.ApplySignal(SQUARE_WAVE,REG0,gz+(kgz*1000)+(mgz*1000000));
    
    gen.EnableOutput(true);   // Turn ON the output - it defaults to OFF

}

void loop() {
  // put your main code here, to run repeatedly:
if (refresh==1){
    LCD_Clear();  
    switch (menu){ 
      case 0:
        if (rezim==SINUS) LCD_Image(0,0,&sinus[0],32,32,0);
        if (rezim==TRIANGLE) LCD_Image(0,0,&triangl[0],32,32,0);
        if (rezim==MEANDR) LCD_Image(0,0,&meandr[0],32,32,0);
          LCD_Goto(46, 0); 
          LCD_Printf("FAZA", 1, 0 );
          LCD_Goto(46, 1);
          Int_To_Buff(faza, buff);
          if (vibor==0)LCD_Printf(buff, 1, 1 ); else LCD_Printf(buff, 1, 0 );
          LCD_Goto(90, 1);
          LCD_Printf("Gr", 1, 0 );
          LCD_Goto(46, 2);
          LCD_Printf("MNOJ", 1, 0 );
          LCD_Goto(46, 3);
          LCD_Printf("X:", 1, 0 );
          LCD_Goto(66, 3);
          Int_To_Buff(mnoj, buff);
          if (vibor==1) LCD_Printf(buff, 1, 1 ); else LCD_Printf(buff, 1, 0 );
          LCD_Goto(0, 5);
          LCD_Printf("CHASTOTA:", 1, 0 );
          LCD_Goto(0, 7);
          Int_To_Buff(mgz, buff);
          if (vibor==4)LCD_Printf(buff, 1, 1 ); else LCD_Printf(buff, 1, 0 );
          LCD_Goto(39, 7);
          Int_To_Buff(kgz, buff);
          if (vibor==3)LCD_Printf(buff, 1, 1 ); else LCD_Printf(buff, 1, 0 );
          LCD_Goto(79, 7);
          Int_To_Buff(gz, buff);
          if (vibor==2)LCD_Printf(buff, 1, 1 ); else LCD_Printf(buff, 1, 0 );
          LCD_Lines(0, 35, 127, 35);
        //  if (rezim==MEANDR) ad9833_set_frequency(0, 2*(gz+(kgz*1000)+(mgz*1000000))); else ad9833_set_frequency(0, gz+(kgz*1000)+(mgz*1000000));
        
       xxx=(float)(gz+(kgz*1000)+(mgz*1000000));
       gen.SetFrequency ( REG0, xxx );
       
       gen.SetPhase ( REG0, faza ) ;
       gen.SetOutputSource(REG0);
     //  gen.EnableOutput(true); 
      break;
      case 10:
        LCD_Image(32,0,&sinus[0],32,32,1);
        LCD_Image(64,0,&triangl[0],32,32,0);
        LCD_Image(32,4,&meandr[0],32,32,0);
        LCD_Image(64,4,&disketa[0],32,32,0);
      break;
      case 11:
        LCD_Image(32,0,&sinus[0],32,32,0);
        LCD_Image(64,0,&triangl[0],32,32,1);
        LCD_Image(32,4,&meandr[0],32,32,0);
        LCD_Image(64,4,&disketa[0],32,32,0);
      break;
      case 12:
        LCD_Image(32,0,&sinus[0],32,32,0);
        LCD_Image(64,0,&triangl[0],32,32,0);
        LCD_Image(32,4,&meandr[0],32,32,1);
        LCD_Image(64,4,&disketa[0],32,32,0);
      break;
      case 13:
        LCD_Image(32,0,&sinus[0],32,32,0);
        LCD_Image(64,0,&triangl[0],32,32,0);
        LCD_Image(32,4,&meandr[0],32,32,0);
        LCD_Image(64,4,&disketa[0],32,32,1);
      break;
      case 14:
        LCD_Image(32,0,&sinus[0],32,32,0);
        LCD_Image(64,0,&triangl[0],32,32,0);
        LCD_Image(32,4,&meandr[0],32,32,0);
        LCD_Image(64,4,&disketa[0],32,32,0);
      break;
    }
  refresh=0;   
  }
  asm volatile("nop"); 
}
